## CsPaint

### Introduction

The CsPaint library is an abstraction of the Vulkan API. This library is intended for software developers who want to
use Vulkan  to render graphics from their application. Using this library will reduce the amount of code required to
render graphics on a GPU. The API of CsPaint provides C++ classes which encapsulates the low level Vulkan API.

A Demo program is provided which contains a few meshes that were modeled in Blender and exported as stl files.  All
rendering in the demo is accomplished by only using the classes available in CsPaint.


### System Requirements

To use CsPaint you will need a C++17 compiler which fully supports the C++17 standard library. You will also need to
download and install the Vulkan SDK from LunarG.

www.lunarg.com/vulkan-sdk/


Currently CsPaint is supported on Linux and Windows.


### Building

CsPaint must be built using CMake 3.8 or newer.


### Documentation

Class level documentation for CsPaint is available on the CopperSpice website:

www.copperspice.com/docs/cs_paint/index.html


### Presentations

Our YouTube channel contains videos about modern C++, graphics, build systems, CopperSpice, DoxyPress, and other
topics related to software development.

https://www.youtube.com/copperspice


Links to technical presentations recorded at CppNow and CppCon:

www.copperspice.com/presentations.html


### Authors / Contributors

* **Ansel Sermersheim**
* **Barbara Geller**


### License

This library is released under the BSD 2-clause license. For more information refer to the LICENSE file provided with
this project.


### References

* Website: www.copperspice.com
* Email:   info@copperspice.com
